#include QMK_KEYBOARD_H
#include "config.h"
#include "version.h"
#include "keymap_steno.h"
#include "g/keymap_combo.h"
#include "music.h"

#define KC_MAC_UNDO LGUI(KC_Z)
#define KC_MAC_CUT LGUI(KC_X)
#define KC_MAC_COPY LGUI(KC_C)
#define KC_MAC_PASTE LGUI(KC_V)
#define KC_PC_UNDO LCTL(KC_Z)
#define KC_PC_CUT LCTL(KC_X)
#define KC_PC_COPY LCTL(KC_C)
#define KC_PC_PASTE LCTL(KC_V)
#define ES_LESS_MAC KC_GRAVE
#define ES_GRTR_MAC LSFT(KC_GRAVE)
#define ES_BSLS_MAC ALGR(KC_6)
#define NO_PIPE_ALT KC_GRAVE
#define NO_BSLS_ALT KC_EQUAL
#define LSA_T(kc) MT(MOD_LSFT | MOD_LALT, kc)
#define BP_NDSH_MAC ALGR(KC_8)

enum custom_keycodes {
  RGB_SLD = ML_SAFE_RANGE,
  HSV_172_255_255,
  ST_MACRO_0,
  ST_MACRO_1,
  ST_MACRO_2,
  ST_MACRO_3,
  ST_MACRO_4,
  ST_MACRO_5,
  ST_MACRO_6,
  ST_MACRO_7,
  ST_MACRO_8,
  ST_MACRO_9,
  ST_MACRO_10,
  ST_MACRO_11,
  ST_MACRO_12,
  ST_MACRO_13,
  ST_MACRO_14,
  ST_MACRO_15,
  ST_MACRO_16,
  ST_MACRO_17,
  ST_MACRO_18,
  ST_MACRO_19,
  ST_MACRO_20,
  ST_MACRO_21,
  ST_MACRO_22,
  ST_MACRO_23,
  ST_MACRO_24,
  ST_MACRO_25,
  ST_MACRO_26,
  ST_MACRO_27,
  ST_MACRO_28,
  ST_MACRO_29,
  ST_MACRO_30,
  ST_MACRO_31,
  ST_MACRO_32,
  ST_MACRO_33,
  ST_MACRO_34,
  PRINT_WPM,
};

#define COLEMAK 0
#define QWERTY 1
#define DVORAK 2
#define SYMNUM 3
#define MEDIA 4
#define DWM 5
#define STENO 6

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
  [0] = LAYOUT_moonlander(
    KC_EQUAL,       KC_1,           KC_2,           KC_3,           KC_4,           KC_5,           KC_LEFT,                                        KC_RIGHT,       KC_6,           KC_7,           KC_8,           KC_9,           KC_0,           KC_MINUS,
    KC_DELETE,      KC_Q,           KC_W,           KC_F,           KC_P,           KC_G,           TG(4),                                          TG(2),          KC_J,           KC_L,           KC_U,           KC_Y,           KC_SCOLON,      KC_BSLASH,
    KC_ESCAPE,      KC_A,           KC_R,           KC_S,           KC_T,           KC_D,           TG(1),                                          TG(5),          KC_H,           KC_N,           KC_E,           KC_I,           KC_O,           KC_QUOTE,
    KC_LSPO,        KC_Z,           KC_X,           KC_C,           KC_V,           KC_B,                                                                           KC_K,           KC_M,           KC_COMMA,       KC_DOT,         KC_SLASH,       KC_RSPC,
    LT(3,KC_GRAVE), KC_LCTRL,       LALT(KC_LSHIFT),KC_LEFT,        KC_RIGHT,       LALT_T(KC_LEAD),                                                            RCTL_T(KC_ESCAPE),  KC_UP,          KC_DOWN,        KC_LBRACKET,    KC_RBRACKET,    MO(3),
    KC_SPACE,       KC_BSPACE,      KC_LGUI,
    KC_COLON,       KC_TAB,         KC_ENTER
  ),
  [1] = LAYOUT_moonlander(
    KC_TRANSPARENT, KC_1,           KC_2,           KC_3,           KC_4,           KC_5,           KC_LEFT,                                        KC_RIGHT,       KC_6,           KC_7,           KC_8,           KC_9,           KC_0,           KC_MINUS,
    KC_TRANSPARENT, KC_Q,           KC_W,           KC_E,           KC_R,           KC_T,           KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_Y,           KC_U,           KC_I,           KC_O,           KC_P,           KC_BSLASH,
    KC_TRANSPARENT, KC_A,           KC_S,           KC_D,           KC_F,           KC_G,           KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_H,           KC_J,           KC_K,           KC_L,           KC_SCOLON,      KC_SPACE,
    KC_TRANSPARENT, KC_Z,           KC_X,           KC_C,           KC_V,           KC_B,                                                                           KC_N,           KC_M,           KC_COMMA,       KC_DOT,         KC_RCTRL,       KC_RSHIFT,
    KC_TRANSPARENT, KC_LGUI,        KC_LALT,        KC_LEFT,        KC_RIGHT,       KC_TRANSPARENT,                                                                 KC_TRANSPARENT, KC_UP,          KC_DOWN,        KC_LBRACKET,    KC_RBRACKET,    TO(0),
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT
  ),
  [2] = LAYOUT_moonlander(
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, KC_QUOTE,       KC_COMMA,       KC_DOT,         KC_P,           KC_Y,           KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_F,           KC_G,           KC_C,           KC_R,           KC_L,           KC_TRANSPARENT,
    KC_TRANSPARENT, KC_A,           KC_O,           KC_E,           KC_U,           KC_I,           KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_D,           KC_H,           KC_T,           KC_N,           KC_S,           KC_TRANSPARENT,
    KC_TRANSPARENT, KC_SCOLON,      KC_Q,           KC_J,           KC_K,           KC_X,                                                                           KC_B,           KC_M,           KC_W,           KC_V,           KC_Z,           KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT
  ),
  [3] = LAYOUT_moonlander(
    KC_ESCAPE,      KC_F1,          KC_F2,          KC_F3,          KC_F4,          KC_F5,          DYN_REC_STOP,                                   DYN_REC_STOP,   KC_F6,          KC_F7,          KC_F8,          KC_F9,          KC_F10,         KC_F11,
    KC_TRANSPARENT, KC_EXLM,        KC_AT,          KC_LCBR,        KC_RCBR,        KC_PIPE,        DYN_REC_START1,                                 DYN_REC_START2, KC_SCROLLLOCK,  KC_7,           KC_8,           KC_9,           KC_ASTR,        KC_F12,
    KC_TRANSPARENT, KC_HASH,        KC_DLR,         KC_LPRN,        KC_RPRN,        KC_GRAVE,       DYN_MACRO_PLAY2,                                DYN_MACRO_PLAY2,KC_NUMLOCK,     KC_4,           KC_5,           KC_6,           KC_KP_PLUS,     KC_MINUS,
    KC_TRANSPARENT, KC_PERC,        KC_CIRC,        KC_LBRACKET,    KC_RBRACKET,    KC_TILD,                                                                        KC_AMPR,        KC_1,           KC_2,           KC_3,           KC_BSLASH,      KC_TRANSPARENT,
    KC_TRANSPARENT, KC_COMMA,       KC_LCTRL,       KC_LALT,        KC_TRANSPARENT, KC_TRANSPARENT,                                                                 RGB_TOG,        KC_RGUI,        KC_DOT,         KC_0,           KC_EQUAL,       KC_TRANSPARENT,
    RGB_VAD,        RGB_VAI,        HSV_172_255_255,
    PRINT_WPM,      RGB_HUD,        RGB_HUI
  ),
  [4] = LAYOUT_moonlander(
    AU_TOG,         TO(6),          KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    MU_TOG,         KC_TRANSPARENT, KC_TRANSPARENT, KC_MS_UP,       KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_UP,          KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    MU_MOD,         KC_TRANSPARENT, KC_MS_LEFT,     KC_MS_DOWN,     KC_MS_RIGHT,    KC_TRANSPARENT, KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_LEFT,        KC_DOWN,        KC_RIGHT,       KC_TRANSPARENT, KC_TRANSPARENT,
    ST_MACRO_0,     KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                                                 KC_TRANSPARENT, KC_TRANSPARENT, KC_MEDIA_PREV_TRACK,KC_MEDIA_NEXT_TRACK,KC_MEDIA_PLAY_PAUSE,KC_TRANSPARENT,
    KC_TRANSPARENT, WEBUSB_PAIR,    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,                                                                 KC_TRANSPARENT, KC_AUDIO_VOL_UP,KC_AUDIO_VOL_DOWN,KC_AUDIO_MUTE,  KC_TRANSPARENT, KC_TRANSPARENT,
    KC_MS_BTN1,     KC_MS_BTN3,     KC_MS_WH_DOWN,
    KC_MS_WH_UP,    KC_TRANSPARENT, KC_MS_BTN2
  ),
  [5] = LAYOUT_moonlander(
    KC_TRANSPARENT, ST_MACRO_1,     ST_MACRO_2,     ST_MACRO_3,     ST_MACRO_4,     ST_MACRO_5,     KC_TRANSPARENT,                                 KC_TRANSPARENT, ST_MACRO_16,    ST_MACRO_17,    ST_MACRO_18,    ST_MACRO_19,    ST_MACRO_20,    KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, ST_MACRO_6,     KC_TRANSPARENT, ST_MACRO_7,     KC_TRANSPARENT,                                 KC_TRANSPARENT, ST_MACRO_21,    ST_MACRO_22,    ST_MACRO_23,    ST_MACRO_24,    ST_MACRO_25,    KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, ST_MACRO_8,     ST_MACRO_9,     ST_MACRO_10,    KC_TRANSPARENT,                                 KC_TRANSPARENT, KC_TRANSPARENT, ST_MACRO_26,    ST_MACRO_27,    ST_MACRO_28,    ST_MACRO_29,    KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, ST_MACRO_11,    KC_TRANSPARENT, ST_MACRO_12,                                                                    KC_TRANSPARENT, ST_MACRO_30,    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT, ST_MACRO_13,    ST_MACRO_14,    KC_LALT,                                                                        KC_TRANSPARENT, ST_MACRO_31,    ST_MACRO_32,    KC_TRANSPARENT, KC_TRANSPARENT, KC_TRANSPARENT,
    ST_MACRO_15,    KC_TRANSPARENT, KC_TRANSPARENT,
    KC_TRANSPARENT, ST_MACRO_33,    ST_MACRO_34
  ),
  [6] = LAYOUT_moonlander(
    TO(0),          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,                                          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,
    KC_NO,          STN_N1,         STN_N2,         STN_N3,         STN_N4,         STN_N5,         KC_NO,                                          KC_NO,          STN_N6,         STN_N7,         STN_N8,         STN_N9,         STN_NA,         STN_NB,
    KC_NO,          STN_S1,         STN_TL,         STN_PL,         STN_HL,         STN_ST1,        KC_NO,                                          KC_NO,          STN_ST3,        STN_FR,         STN_PR,         STN_LR,         STN_TR,         STN_DR,
    KC_NO,          STN_S2,         STN_KL,         STN_WL,         STN_RL,         STN_ST2,                                                                        STN_ST4,        STN_RR,         STN_BR,         STN_GR,         STN_SR,         STN_ZR,
    KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,                                                                          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,          KC_NO,
    STN_A,          STN_O,          STN_ST2,
    STN_ST3,        STN_E,          STN_U
  ),
};

extern bool g_suspend_state;
extern rgb_config_t rgb_matrix_config;

void keyboard_post_init_user(void) {
  rgb_matrix_enable();
}

const uint8_t PROGMEM ledmap[][DRIVER_LED_TOTAL][3] = {
    [0] = { {0,0,0}, {0,0,0}, {0,0,0}, {240,108,244}, {240,108,244}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {240,108,244}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {240,108,244}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {250,159,255}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {250,159,255}, {211,141,176}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {229,176,197}, {229,176,197}, {0,0,0}, {0,0,0}, {250,159,255}, {240,108,244}, {0,0,0}, {0,0,0}, {0,0,0}, {240,108,244}, {240,108,244}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {0,0,0}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {0,0,0}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {250,159,255}, {211,141,176}, {0,0,0}, {7,84,227}, {0,0,0}, {250,159,255}, {211,141,176}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {229,176,197}, {229,176,197}, {0,0,0}, {0,0,0}, {250,159,255}, {240,108,244} },

    [1] = { {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {141,255,233}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255}, {2,255,255} },

    [2] = { {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {12,225,241}, {169,120,255}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {0,0,172}, {74,220,162}, {74,220,162}, {32,255,234}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162}, {169,120,255}, {146,224,255}, {74,220,162}, {74,220,162}, {74,220,162}, {74,220,162} },

    [3] = { {15,97,236}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {250,159,255}, {27,126,255}, {31,255,255}, {31,255,255}, {31,255,255}, {250,159,255}, {27,126,255}, {31,255,255}, {31,255,255}, {31,255,255}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,183,238}, {15,176,169}, {15,176,169}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {250,159,255}, {27,126,255}, {0,0,0}, {0,0,0}, {0,0,0}, {0,183,238}, {15,97,236}, {15,97,236}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0} },

    [4] = { {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,13,207}, {23,159,109}, {23,159,109}, {23,159,109}, {23,13,207}, {23,13,207}, {23,159,109}, {0,0,43}, {23,159,109}, {23,159,109}, {23,13,207}, {22,36,120}, {0,0,43}, {23,159,109}, {23,159,109}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {23,159,109}, {23,159,109}, {22,36,120}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {23,159,109}, {1,218,204}, {23,159,109}, {23,159,109}, {23,159,109}, {1,218,204}, {0,0,255}, {23,159,109}, {23,159,109}, {23,159,109}, {1,218,204}, {0,0,255}, {23,159,109}, {23,159,109}, {1,218,204}, {22,36,120}, {0,0,255}, {23,159,109}, {1,218,204}, {22,36,120}, {22,36,120}, {1,218,204}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120}, {22,36,120} },

    [5] = { {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {112,52,165}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {112,52,165}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {112,52,165}, {30,207,250}, {43,203,187}, {30,207,250}, {19,229,254}, {112,52,165}, {0,0,0}, {4,202,251}, {0,0,0}, {19,229,254}, {112,52,165}, {4,202,251}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {4,202,251}, {0,0,0}, {0,0,0}, {43,203,187}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {112,52,165}, {30,207,250}, {43,203,187}, {0,0,0}, {0,0,0}, {112,52,165}, {4,202,251}, {43,203,187}, {0,0,0}, {0,0,0}, {112,52,165}, {43,203,187}, {43,203,187}, {0,0,0}, {19,229,254}, {112,52,165}, {4,202,251}, {43,203,187}, {4,202,251}, {19,229,254}, {112,52,165}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {30,207,250}, {112,52,165}, {43,203,187}, {0,0,0} },

    [6] = { {0,205,155}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {0,0,0}, {250,159,255}, {14,222,242}, {14,222,242}, {0,0,0}, {0,0,0}, {250,159,255}, {255,220,201}, {255,220,201}, {0,0,0}, {0,0,0}, {250,159,255}, {233,218,217}, {233,218,217}, {0,0,0}, {0,0,0}, {250,159,255}, {205,255,255}, {205,255,255}, {0,0,0}, {0,0,0}, {250,159,255}, {211,141,176}, {211,141,176}, {0,0,0}, {0,0,0}, {0,0,0}, {255,220,201}, {233,218,217}, {211,141,176}, {0,0,0}, {0,0,0}, {250,159,255}, {14,222,242}, {14,222,242}, {0,0,0}, {0,0,0}, {250,159,255}, {14,222,242}, {14,222,242}, {0,0,0}, {0,0,0}, {250,159,255}, {255,220,201}, {255,220,201}, {0,0,0}, {0,0,0}, {250,159,255}, {233,218,217}, {233,218,217}, {0,0,0}, {0,0,0}, {250,159,255}, {205,255,255}, {205,255,255}, {0,0,0}, {0,0,0}, {250,159,255}, {211,141,176}, {211,141,176}, {0,0,0}, {0,0,0}, {0,0,0}, {255,220,201}, {233,218,217}, {211,141,176}, {0,0,0} },

};

void set_layer_color(int layer) {
  for (int i = 0; i < DRIVER_LED_TOTAL; i++) {
    HSV hsv = {
      .h = pgm_read_byte(&ledmap[layer][i][0]),
      .s = pgm_read_byte(&ledmap[layer][i][1]),
      .v = pgm_read_byte(&ledmap[layer][i][2]),
    };
    if (!hsv.h && !hsv.s && !hsv.v) {
        rgb_matrix_set_color( i, 0, 0, 0 );
    } else {
        RGB rgb = hsv_to_rgb( hsv );
        float f = (float)rgb_matrix_config.hsv.v / UINT8_MAX;
        rgb_matrix_set_color( i, f * rgb.r, f * rgb.g, f * rgb.b );
    }
  }
}

void rgb_matrix_indicators_user(void) {
  if (g_suspend_state || keyboard_config.disable_layer_led) { return; }
  switch (biton32(layer_state)) {
    case 0:
      set_layer_color(0);
      break;
    case 1:
      set_layer_color(1);
      break;
    case 2:
      set_layer_color(2);
      break;
    case 3:
      set_layer_color(3);
      break;
    case 4:
      set_layer_color(4);
      break;
    case 5:
      set_layer_color(5);
      break;
    case 6:
      set_layer_color(6);
      break;
   default:
    if (rgb_matrix_get_flags() == LED_FLAG_NONE)
      rgb_matrix_set_color_all(0, 0, 0);
    break;
  }
}

bool process_record_user(uint16_t keycode, keyrecord_t *record) {
  switch (keycode) {
    case ST_MACRO_0:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_PSCREEN)));

    }
    break;
    case ST_MACRO_1:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_1)));

    }
    break;
    case ST_MACRO_2:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_2)));

    }
    break;
    case ST_MACRO_3:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_3)));

    }
    break;
    case ST_MACRO_4:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_4)));

    }
    break;
    case ST_MACRO_5:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_5)));

    }
    break;
    case ST_MACRO_6:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_E)));

    }
    break;
    case ST_MACRO_7:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_T)));

    }
    break;
    case ST_MACRO_8:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_D)));

    }
    break;
    case ST_MACRO_9:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_F)));

    }
    break;
    case ST_MACRO_10:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_LSFT(SS_TAP(X_SPACE))));

    }
    break;
    case ST_MACRO_11:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_LSFT(SS_TAP(X_C))));

    }
    break;
    case ST_MACRO_12:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_B)));

    }
    break;
    case ST_MACRO_13:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_COMMA)));

    }
    break;
    case ST_MACRO_14:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_DOT)));

    }
    break;
    case ST_MACRO_15:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_SPACE)));

    }
    break;
    case ST_MACRO_16:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_6)));

    }
    break;
    case ST_MACRO_17:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_7)));

    }
    break;
    case ST_MACRO_18:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_8)));

    }
    break;
    case ST_MACRO_19:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_9)));

    }
    break;
    case ST_MACRO_20:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_0)));

    }
    break;
    case ST_MACRO_21:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_LSFT(SS_TAP(X_0))));

    }
    break;
    case ST_MACRO_22:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_U)));

    }
    break;
    case ST_MACRO_23:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_I)));

    }
    break;
    case ST_MACRO_24:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_O)));

    }
    break;
    case ST_MACRO_25:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_P)));

    }
    break;
    case ST_MACRO_26:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_H)));

    }
    break;
    case ST_MACRO_27:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_J)));

    }
    break;
    case ST_MACRO_28:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_K)));

    }
    break;
    case ST_MACRO_29:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_L)));

    }
    break;
    case ST_MACRO_30:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_M)));

    }
    break;
    case ST_MACRO_31:
    if (record->event.pressed) {
      SEND_STRING(SS_TAP(X_DOT));

    }
    break;
    case ST_MACRO_32:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_LSFT(SS_TAP(X_COMMA))));

    }
    break;
    case ST_MACRO_33:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_TAP(X_TAB)));

    }
    break;
    case ST_MACRO_34:
    if (record->event.pressed) {
      SEND_STRING(SS_LALT(SS_LSFT(SS_TAP(X_ENTER))));

    }
    break;
    case RGB_SLD:
      if (record->event.pressed) {
        rgblight_mode(1);
      }
      return false;
    case HSV_172_255_255:
      if (record->event.pressed) {
        rgblight_mode(1);
        rgblight_sethsv(172,255,255);
      }
      return false;
    case PRINT_WPM:
      if (record->event.pressed) {
          //send_string("Current WPM: %d\n", get_current_wpm());
      }
      return false;
  }
  return true;
}

void matrix_init_user() {
    steno_set_mode(STENO_MODE_GEMINI); // or STENO_MODE_BOLT
    autoshift_enable();
}

layer_state_t layer_state_set_user(layer_state_t state) {
    switch (get_highest_layer(state)) {
        case COLEMAK:
            break;
        case QWERTY:
            break;
        case DVORAK:
            break;
        case SYMNUM:
            break;
        case MEDIA:
            break;
        case DWM:
            break;
        case STENO:
            PLAY_SONG(sonic_ring);
            break;
    }

    return state;
}
