#include QMK_KEYBOARD_H
#include "config.h"
#include "version.h"

extern void combo_enable(void);
extern void combo_disable(void);

LEADER_EXTERNS();

void matrix_scan_user(void) {
    LEADER_DICTIONARY() {
        leading = false;
        leader_end();

        // Proxytags
        SEQ_TWO_KEYS(KC_P, KC_C) { SEND_STRING("Cadey\\ "); }
        SEQ_TWO_KEYS(KC_P, KC_N) { SEND_STRING("Nicole\\ "); }
        SEQ_TWO_KEYS(KC_P, KC_J) { SEND_STRING("Jessie\\ "); }
        SEQ_TWO_KEYS(KC_P, KC_A) { SEND_STRING("Ashe\\ "); }
        SEQ_TWO_KEYS(KC_P, KC_S) { SEND_STRING("Sephie\\ "); }
        SEQ_TWO_KEYS(KC_P, KC_M) { SEND_STRING("Mai\\ "); }

        // Combos
        SEQ_TWO_KEYS(KC_C, KC_D) { combo_disable(); }
        SEQ_TWO_KEYS(KC_C, KC_E) { combo_enable(); }

        // Autoshift
        SEQ_THREE_KEYS(KC_A, KC_S, KC_T) { autoshift_toggle(); }
        SEQ_THREE_KEYS(KC_A, KC_S, KC_E) { autoshift_enable(); }
        SEQ_THREE_KEYS(KC_A, KC_S, KC_D) { autoshift_disable(); }

        // Go
        SEQ_THREE_KEYS(KC_G, KC_I, KC_E) {
            SEND_STRING("if err != nil {\n\t\n}");
        }

        // k8s
        SEQ_THREE_KEYS(KC_K, KC_G, KC_D) { SEND_STRING("kubectl get deployments "); }
        SEQ_THREE_KEYS(KC_K, KC_G, KC_P) { SEND_STRING("kubectl get pods "); }
        SEQ_THREE_KEYS(KC_K, KC_G, KC_N) { SEND_STRING("kubectl get nodes -o wide "); }
        SEQ_TWO_KEYS(KC_K, KC_L) { SEND_STRING("kubectl logs "); }
        SEQ_THREE_KEYS(KC_K, KC_L, KC_D) { SEND_STRING("kubectl logs deployment/"); }
        SEQ_TWO_KEYS(KC_K, KC_V) { SEND_STRING("kubectl version "); }
        SEQ_TWO_KEYS(KC_K, KC_I) { SEND_STRING("kubectl exec -it "); }
        SEQ_TWO_KEYS(KC_K, KC_D) { SEND_STRING("kubectl describe "); }

        // Git
        SEQ_TWO_KEYS(KC_G, KC_P) { SEND_STRING("git push"); }
        SEQ_THREE_KEYS(KC_G, KC_F, KC_P) { SEND_STRING("git push --force-with-lease"); }
        SEQ_TWO_KEYS(KC_G, KC_U) { SEND_STRING("git pull"); }
        SEQ_TWO_KEYS(KC_G, KC_A) { SEND_STRING("git add ."); }
        SEQ_TWO_KEYS(KC_G, KC_D) { SEND_STRING("git diff"); }
        SEQ_THREE_KEYS(KC_G, KC_D, KC_S) { SEND_STRING("git diff --staged"); }
        SEQ_TWO_KEYS(KC_G, KC_L) { SEND_STRING("git log"); }
        SEQ_THREE_KEYS(KC_G, KC_L, KC_O) { SEND_STRING("git log --oneline"); }
        SEQ_TWO_KEYS(KC_G, KC_O) { SEND_STRING("git checkout"); }
        SEQ_THREE_KEYS(KC_G, KC_O, KC_B) { SEND_STRING("git checkout -b"); }
        SEQ_TWO_KEYS(KC_G, KC_S) { SEND_STRING("git status"); }
        SEQ_TWO_KEYS(KC_G, KC_C) { SEND_STRING("git commit -m ''"); }
        SEQ_THREE_KEYS(KC_G, KC_C, KC_A) { SEND_STRING("git commit --amend"); }

        // copypastas
        SEQ_THREE_KEYS(KC_P, KC_N, KC_B) {
            SEND_STRING("Non-binary gender identity is just one term used to describe individuals who may experience a gender identity that is neither exclusively male or female or is in between or beyond both genders.﻿ Non-binary individuals may identify as gender fluid, agender (without gender), third gender, or something else entirely.");
        }
        SEQ_THREE_KEYS(KC_P, KC_B, KC_M) {
            SEND_STRING("this sentence makes you breathe manually");
        }
    }
}
